library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

--  Uncomment the following lines to use the declarations that are
--  provided for instantiating Xilinx primitive components.
--library UNISIM;
--use UNISIM.VComponents.all;

entity btn_debounce is
    Port ( clk100 : in std_logic;
           res 		: in std_logic;
					 hold		: in std_logic;
           i 			: in std_logic;
           o 			: out std_logic);
end btn_debounce;

architecture Behavioral of btn_debounce is

	signal btn_z1 : std_logic;
	signal btn_z2 : std_logic;

begin

	process (clk100, res, hold, i)
	begin
		if (res = '1') then
		  btn_z1 <= '0';
		  btn_z2 <= '0';
		elsif clk100'event and clk100 = '1' then
		  if hold = '1' then
				o <= 			btn_z2 and btn_z1 and i;
			else
				o <= not  btn_z2 and btn_z1 and i;
			end if;
			
			btn_z1 <= i;
			btn_z2 <= btn_z1;
		end if;
	end process;


end Behavioral;
